unit MainUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    StartLoggingButton: TButton;
    StopLoggingButton: TButton;
    Label1: TLabel;
    procedure StartLoggingButtonClick(Sender: TObject);
    procedure StopLoggingButtonClick(Sender: TObject);
  private
    { Private declarations }
  public

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

const
  SharedBufferSize=1024;   

  DLLName='hookDLL.dll';
  
  FileMappingName = 'WinHookSharedMemoryName';

procedure SetMsgHook; stdcall; external DLLName;
procedure DelMsgHook; stdcall; external DLLName;

var
  FileMappingHandle:THandle = 0;
  SharedBuffer:pointer= nil;

function GetControlHandle:THandle;
begin
  Result:=FindWindow('NOTEPAD',0);
  Result:=FindWindowEx(Result,0,'EDIT',0);
      
end;

procedure RunHook;
begin
  FileMappingHandle:=CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,SharedBufferSize,FileMappingName);
  SharedBuffer:=MapViewOfFile(FileMappingHandle,FILE_MAP_WRITE,0,0,SharedBufferSize);
  ZeroMemory(SharedBuffer,SharedBufferSize);
  DWORD(SharedBuffer^):=GetControlHandle;
  SetMsgHook;
end;

procedure StopHook;
begin
  DelMsgHook;
  UnmapViewOfFile(SharedBuffer);
  CloseHandle(FileMappingHandle);
end;


procedure TMainForm.StartLoggingButtonClick(Sender: TObject);
begin
  RunHook ;

end;

procedure TMainForm.StopLoggingButtonClick(Sender: TObject);
begin

  StopHook;
end;

end.
